-- Lulu88520
-- Script pour KongskildeCH3000
-- @date  22/04/2016
-- https://www.facebook.com/paulo5090r

KongskildeCH3000 = {};

function KongskildeCH3000.prerequisitesPresent(specializations)
	  return true;
end;

function KongskildeCH3000:load(xmlFile)  
self.updateJoint = false;
	self.aiTerrainDetailChannelBackUp1 = nil;
	self.aiTerrainDetailChannelBackUp2 = nil;	
	self.aiLeftMarkerBackUp = self.aiLeftMarker;
    self.aiRightMarkerBackUp = self.aiRightMarker;
    self.aiBackMarkerBackUp = self.aiBackMarker;	
	self.setTerrainDetailChannels = false;
	self.aiActiveSpeedMultiplicator = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hitchMoveTime#aiActiveSpeedMultiplicator"), 1);
	self.aiDeactiveSpeedMultiplicator = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hitchMoveTime#aiDeactiveSpeedMultiplicator"), 1);
	self.currentLiftSpeed = self.aiDeactiveSpeedMultiplicator;
	
	self.troisPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.troisPoint#index"));
	setVisibility(self.troisPoint, false);
end;

function KongskildeCH3000:delete()
end;

function KongskildeCH3000:readStream(streamId, connection)   
end;

function KongskildeCH3000:writeStream(streamId, connection)
end;

function KongskildeCH3000:mouseEvent(posX, posY, isDown, isUp, button)
end;

function KongskildeCH3000:keyEvent(unicode, sym, modifier, isDown) 
end;

function KongskildeCH3000:update(dt)	
	if self:getIsActiveForInput() and self:getIsActive() then
		local isKeyEvent = false;	
			if InputBinding.isPressed(InputBinding.MONTER_RELEVAGE) and self:getIsActiveForInput() then
				self:setAnimationTime(1, self.animationParts[1].currentPosition+(self.animationParts[1].offSet*(dt/10)));
				isKeyEvent = true;
			elseif InputBinding.isPressed(InputBinding.BAISSER_RELEVAGE) and self:getIsActiveForInput() then
				self:setAnimationTime(1, self.animationParts[1].currentPosition-(self.animationParts[1].offSet*(dt/10)));
				isKeyEvent = true;
			end;		
	end;
	if self:getIsActive() then
		for _, part in pairs(self.movingParts) do
			Cylindered.setDirty(self, part);
		end;
	end;
end;

function KongskildeCH3000:updateTick(dt)
if self.setTerrainDetailChannels then
		if table.getn(self.attachedImplements) > 0 then
			for k,implement in pairs(self.attachedImplements) do
				if implement.object.aiTerrainDetailChannel1 ~= nil and implement.object.aiTerrainDetailChannel2 ~= nil and implement.object.aiLeftMarker ~= nil and implement.object.aiRightMarker ~= nil and implement.object.aiBackMarker ~= nil then
					self.aiTerrainDetailChannelBackUp1 = self.aiTerrainDetailChannel1;
					self.aiTerrainDetailChannelBackUp2 = self.aiTerrainDetailChannel2;
					self.aiTerrainDetailChannel1 = implement.object.aiTerrainDetailChannel1;
					self.aiTerrainDetailChannel2 = implement.object.aiTerrainDetailChannel2;
					self.aiLeftMarker = implement.object.aiLeftMarker;
					self.aiRightMarker = implement.object.aiRightMarker;
					self.aiBackMarker = implement.object.aiBackMarker;
				end;
			end;
		else
			if self.aiTerrainDetailChannelBackUp1 ~= nil and self.aiTerrainDetailChannelBackUp2 ~= nil and self.aiLeftMarkerBackUp ~= nil and self.aiRightMarkerBackUp ~= nil and self.aiBackMarkerBackUp ~= nil then
				self.aiTerrainDetailChannel1 = self.aiTerrainDetailChannelBackUp1;
				self.aiTerrainDetailChannel2 = self.aiTerrainDetailChannelBackUp2;
				self.aiTerrainDetailChannelBackUp1 = nil;
				self.aiTerrainDetailChannelBackUp2 = nil;
				self.aiLeftMarker = self.aiLeftMarkerBackUp;
				self.aiRightMarker = self.aiRightMarkerBackUp;
				self.aiBackMarker = self.aiBackMarkerBackUp;
			end;
		end;
		self.setTerrainDetailChannels = false;
	end;
	if self:getIsActive() then
		self.currentLiftSpeed = self.aiDeactiveSpeedMultiplicator;
		self.updateJoint = true;
		if self.attacherVehicle ~= nil then
			if self.attacherVehicle.isHired ~= nil then
				self.currentLiftSpeed = self.aiActiveSpeedMultiplicator;
			end;
			-- if self.attacherVehicle.isHired and table.getn(self.attachedImplements) > 0 then
				-- for k, implement in pairs(self.attacherVehicle.attachedImplements) do
					-- if implement.object == self then
						-- if self.attacherVehicle.attacherJoints[implement.jointDescIndex].moveDown then
							-- self:setAnimationTime(1, self.animationParts[1].currentPosition);  
								-- else
							  
							-- self:setAnimationTime(1, self.animationParts[1].animDuration);
						-- end;
					-- end;
				-- end;
			-- end;
		end;		
	end; 
end;
  
function KongskildeCH3000:onDetach()
end;

function KongskildeCH3000:detachImplement(implementIndex)	
	setVisibility(self.troisPoint, false);
	self.setTerrainDetailChannels = true;
end;

function KongskildeCH3000:attachImplement(implement)
	setVisibility(self.troisPoint, true);
	self.setTerrainDetailChannels = true;
end;

function KongskildeCH3000:onAttach()
end;
if g_currentModName ~= "Pack_Kongskilde_CH" then
	while g_currentModName ~= "Pack_Kongskilde_CH" do
	print("Error: The mod must not be renamed. It must be called Pack_Kongskilde_CH.zip");	
	end;
end;
function KongskildeCH3000:draw() 
 if self.isClient and self:getIsActiveForInput(true) then 
	    if self.animationParts[1].clip then			
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("MONTER_RELEVAGE")), InputBinding.MONTER_RELEVAGE);
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BAISSER_RELEVAGE")), InputBinding.BAISSER_RELEVAGE);
	    end;		
end;
end;

function KongskildeCH3000:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;
